--Made by Sz_/Appleblurt/Man553, cheers ^^

freeslot(
	"SFX_CHGECS","SFX_CHAOSS","SFX_CHAOSB","SFX_CSPEAR","SFX_CSSFX1",
	"MT_ACHAOSSPEAR","S_ACHAOSSPEARSTATE1","S_ACHAOSSPEARSTATE2",
	"S_ACHAOSSPEARSTATE3","MT_EXPLODINGACHAOSSPEAR",
	"S_EXPLODINGACHAOSSPEAR1","S_EXPLODINGACHAOSSPEAR2",
	"S_EXPLODINGACHAOSSPEAR3","S_EXPLODINGACHAOSSPEAR4",
	"S_SPEAREXPLOSION1", "S_SPEAREXPLOSION2", "S_SPEAREXPLOSION3",
	"S_SPEAREXPLOSION4", "S_SPEAREXPLOSION5", "S_SPEAREXPLOSION6",
	"S_SPEAREXPLOSION7", "SPR_F993", "SPR_CHSP"
)

sfxinfo[sfx_chgecs].caption = '"Chaos.."'
sfxinfo[sfx_chaoss].caption = '"Spear!"'
sfxinfo[sfx_chaosb].caption = '"Chaos.. ..blast!"'
sfxinfo[sfx_cspear].caption = "Spear whooshing"
sfxinfo[sfx_cssfx1].caption = "Whzzz"

local floatTime = TICRATE+TICRATE/2
local abilityTime = TICRATE*3+TICRATE/2
local floatPower = 6

-- ..thanks flame :P
local function LookForEnemies(p)
	local lastmo
	local dist
	local lastdist = 0

	for mo in mobjs.iterate()
		if mo == p.mo // 'Ignore us' check
			continue
		end
		if (mo.health <= 0) // I'm Dead.
			continue
		end
		//Ignore anything EXCEPT Crawlas
		if not ((mo.flags & MF_ENEMY) 
		or (mo.flags & MF_BOSS))
			continue
		end
		// Can't get it if you can't see it!
		if not P_CheckSight(p.mo,mo)
			continue
		end
		dist = P_AproxDistance(P_AproxDistance(p.mo.x - mo.x, p.mo.y - mo.y), p.mo.z - mo.z)
		if (lastmo and (dist > lastdist)) // Last one is closer to you?
			continue
		end
		// Found a target
		lastmo = mo
		lastdist = dist
	end
	return lastmo
end

local function ableTo(player)
	if (player.mo and player.mo.valid)
	and (player.powers[pw_carry] == CR_NONE)
	and (player.playerstate == PST_LIVE)
	and not (player.pflags & PF_FINISHED)
	and not (player.exiting)
	and not (P_PlayerInPain(player))
		return true
	else
		return false
	end
end

addHook("PlayerThink", function(player)
	if (player.mo and player.mo.valid and player.mo.skin == "shadow")
		player.floatUp = $ or 0
		player.floatAbility = $ or 0
		if (player.floatUp == 0) 
		and (player.cmd.buttons & BT_ATTACK) 
		and (P_IsObjectOnGround(player.mo))
		and (ableTo(player))
		and (((player.cmd.buttons & BT_CUSTOM1) and not (player.cmd.buttons & BT_CUSTOM2))
		or ((player.cmd.buttons & BT_CUSTOM2) and not (player.cmd.buttons & BT_CUSTOM1)))
			if (player.cmd.buttons & BT_CUSTOM1)
				player.floatAbility = 1
				S_StartSound(player.mo, sfx_chgecs)
			else
				player.floatAbility = 2
				S_StartSound(player.mo, sfx_chaosb)
			end
			player.mo.state = S_PLAY_FALL
			P_SpawnGhostMobj(player.mo)
			player.floatUp = 1
		end
		if (player.floatUp > 0)
			player.mo.state = S_PLAY_FALL
			if (player.floatAbility == 1)
				if (player.floatAbility == 1) and (player.cmd.buttons & BT_USE)
					local enemy = LookForEnemies(player)
					if (enemy) 
						P_SpawnLockOn(player, enemy, S_LOCKON1)
						local distance = R_PointToDist2(player.mo.x, player.mo.y, enemy.x, enemy.y)
						local zdifference = (enemy.z - enemy.height/2 - player.mo.z)
						player.mo.angle = R_PointToAngle2(player.mo.x, player.mo.y, enemy.x, enemy.y)	
						player.aiming = R_PointToAngle2(0, 0, distance, zdifference)
					end
				end
				player.drawangle = player.mo.angle
			end
			if not (ableTo(player))
				player.floatUp = 0
			end
			if (player.floatUp < 12)
				player.mo.frame = 0
				floatPower = player.floatUp/2
			else
				if (player.floatUp > floatTime)
					if (player.floatAbility == 1) and (player.floatUp % 15 == 0)
						local bullet = P_SpawnPlayerMissile(player.mo, MT_ACHAOSSPEAR)
						P_TeleportMove(bullet,
							player.mo.x+P_ReturnThrustX(player.mo, player.mo.angle, 20*FRACUNIT),
							player.mo.y+P_ReturnThrustY(player.mo, player.mo.angle, 20*FRACUNIT),
							player.mo.z+player.mo.height/2
						)						
						bullet.target = player.mo
						P_Thrust(player.mo, player.mo.angle, -8*FRACUNIT)
					end
					if (floatPower > 0)
						// adding this line here so it doesnt look confusing
						if (floatPower == 6) and (player.floatAbility == 1)
							S_StartSound(player.mo, sfx_chaoss)
						end
						if (player.floatAbility == 2)
							if (floatPower == 6)
								S_StartSound(nil, sfx_bkpoof)
								P_StartQuake(100*FRACUNIT, TICRATE)
								P_FlashPal(player, PAL_NUKE, 10)
								P_NukeEnemies(player.mo, player.mo, 1536*FRACUNIT)
							end
							player.mo.sprite2 = SPR2_BATB
							player.mo.frame = D
						end
						floatPower = $ - 1
					end
				else
					if (player.floatAbility == 2)
						player.mo.sprite2 = SPR2_BATN
						player.mo.frame = C
					end
					floatPower = 6
				end
			end
			player.pflags = $|PF_FULLSTASIS
			player.mo.momx = $ - $ / 8
			player.mo.momy = $ - $ / 8
			player.floatUp = $ + 1
			player.mo.momz = floatPower*FRACUNIT*P_MobjFlip(player.mo)
			if (player.floatUp > floatTime) and (P_IsObjectOnGround(player.mo))
				player.floatUp = 0
			end
			if (player.floatUp > abilityTime)
				player.floatUp = 0
			end
		end
	else
		player.floatUp = 0
		player.floatAbility = 0
	end
end)

addHook("MobjCollide", function(mobj, mobj2)
	if (mobj.valid) and (mobj2.player) and (mobj2.valid) and (mobj.target == mobj2)
		return false
	end
end, MT_ACHAOSSPEAR)